#
# ISP RAS (http://www.ispras.ru)
#
# This ruby template was automatically generated by the MicroTESK tool
# Generation started: Fri Dec 27 11:14:34 MSK 2019
#

require_relative 'minimips_base'

class GroupGenTemplate < MiniMipsBaseTemplate
  def pre
    super
    data {
      label :data
      word rand(1, 9), rand(1, 9), rand(1, 9), rand(1, 9)
      label :end_data
      space 1
    }
  end
  
  def run
    set_default_allocator FREE
    
    #  BRANCH_OPERATIONS
    sequence {
      
      bgez reg(_), :bgez_label
      nop
      label :bgez_label
      nop
      
      bltzal reg(_), :bltzal_label
      nop
      label :bltzal_label
      nop
      
      bne reg(_), reg(_), :bne_label
      nop
      label :bne_label
      nop
      
      jal :jal_label
      nop
      label :jal_label
      nop
      
      bgezal reg(_), :bgezal_label
      nop
      label :bgezal_label
      nop
      
      beq reg(_), reg(_), :beq_label
      nop
      label :beq_label
      nop
      
      la reg(3), :jr_label
      jr reg(3)
      nop
      label :jr_label
      nop
      
      bgtz reg(_), :bgtz_label
      nop
      label :bgtz_label
      nop
      
      blez reg(_), :blez_label
      nop
      label :blez_label
      nop
      
      bltz reg(_), :bltz_label
      nop
      label :bltz_label
      nop
      
      la reg(3), :jalr_label
      jalr reg(_), reg(3)
      nop
      label :jalr_label
      nop
      
      j :j_label
      nop
      label :j_label
      nop
    }.run
    
    block(:combinator => 'product', :compositor => 'random') {
      #  STORE_OPERATIONS
      iterate {
        
        sequence {
          la reg(5), :data
          sw reg(5), :data, reg(5)
        }
        
        sequence {
          la reg(5), :data
          swc0 rcop0(5), :data, reg(5)
        }
      }
      #  LOAD_OPERATIONS
      iterate {
        
        sequence {
          la reg(5), :data
          lwc0 rcop0(_), :data, reg(5)
        }
        
        sequence {
          la reg(5), :data
          lw reg(_), :data, reg(5)
        }
      }
      #  ARITHMETIC_OPERATIONS
      iterate {
        
        xor reg(_), reg(_), reg(_)
        
        slt reg(_), reg(_), reg(_)
        
        sltiu reg(_), reg(_), _
        
        ori reg(_), reg(_), _
        
        subu reg(_), reg(_), reg(_)
        
        xori reg(_), reg(_), _
        
        addi reg(_), reg(_), _
        
        addu reg(_), reg(_), reg(_)
        
        nor reg(_), reg(_), reg(_)
        
        add reg(_), reg(_), reg(_)
        
        OR reg(_), reg(_), reg(_)
        
        srl reg(_), reg(_), _
        
        addiu reg(_), reg(_), _
        
        andi reg(_), reg(_), _
        
        sra reg(_), reg(_), _
        
        srlv reg(_), reg(_), reg(_)
        
        slti reg(_), reg(_), _
        
        sltu reg(_), reg(_), reg(_)
        
        sllv reg(_), reg(_), reg(_)
        
        srav reg(_), reg(_), reg(_)
        
        sub reg(_), reg(_), reg(_)
        
        AND reg(_), reg(_), reg(_)
        
        sll reg(_), reg(_), _
      }
    }.run
  end
end
